#define Win32

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace HealthBarProject
{
    public interface IUserInputService 
    {
        ButtonState A(PlayerIndex index);
        ButtonState B(PlayerIndex index);
        ButtonState X(PlayerIndex index);
        ButtonState Y(PlayerIndex index);
        ButtonState Back(PlayerIndex index);
        ButtonState Start(PlayerIndex index);
        ButtonState LeftSholder(PlayerIndex index);
        ButtonState LeftStick(PlayerIndex index);
        ButtonState RightSholder(PlayerIndex index);
        ButtonState RightStick(PlayerIndex index);
        ButtonState Left(PlayerIndex index);
        ButtonState Right(PlayerIndex index);
        ButtonState Up(PlayerIndex index);
        ButtonState Down(PlayerIndex index);
        Vector2 LeftThumbStick(PlayerIndex index);
        Vector2 RightThumbStick(PlayerIndex index);
        float LeftTrigger(PlayerIndex index);
        float RightTrigger(PlayerIndex index);
        bool IsConnected(PlayerIndex index);
        bool IsKeyDown(Keys key);
        bool IsKeyUp(Keys key);
        Keys[] PressedKeys();
#if Win32
        bool IsLeftMouseButtonDown { get; }
        bool IsRightMouseButtonDown { get; }
        bool IsMiddleMouseButtonDown { get; }
        bool IsXButton1MouseButtonDown { get; }
        bool IsXButton2MouseButtonDown { get; }
        bool IsLeftMouseButtonUp { get; }
        bool IsRightMouseButtonUp { get; }
        bool IsMiddleMouseButtonUp { get; }
        bool IsXButton1MouseButtonUp { get; }
        bool IsXButton2MouseButtonUp { get; }
        int MouseX { get; }
        int MouseY { get; }
        int MouseScrollWheel { get; }
#endif

        ButtonState PreviousA(PlayerIndex index);
        ButtonState PreviousB(PlayerIndex index);
        ButtonState PreviousX(PlayerIndex index);
        ButtonState PreviousY(PlayerIndex index);
        ButtonState PreviousBack(PlayerIndex index);
        ButtonState PreviousStart(PlayerIndex index);
        ButtonState PreviousLeftSholder(PlayerIndex index);
        ButtonState PreviousLeftStick(PlayerIndex index);
        ButtonState PreviousRightSholder(PlayerIndex index);
        ButtonState PreviousRightStick(PlayerIndex index);
        ButtonState PreviousLeft(PlayerIndex index);
        ButtonState PreviousRight(PlayerIndex index);
        ButtonState PreviousUp(PlayerIndex index);
        ButtonState PreviousDown(PlayerIndex index);
        Vector2 PreviousLeftThumbStick(PlayerIndex index);
        Vector2 PreviousRightThumbStick(PlayerIndex index);
        float PreviousLeftTrigger(PlayerIndex index);
        float PreviousRightTrigger(PlayerIndex index);
        bool PreviousIsConnected(PlayerIndex index);
        bool WasKeyDown(Keys key);
        bool WasKeyUp(Keys key);
        Keys[] PreviouslyPressedKeys();
#if Win32
        bool WasLeftMouseButtonDown { get; }
        bool WasRightMouseButtonDown { get; }
        bool WasMiddleMouseButtonDown { get; }
        bool WasXButton1MouseButtonDown { get; }
        bool WasXButton2MouseButtonDown { get; }
        bool WasLeftMouseButtonUp { get; }
        bool WasRightMouseButtonUp { get; }
        bool WasMiddleMouseButtonUp { get; }
        bool WasXButton1MouseButtonUp { get; }
        bool WasXButton2MouseButtonUp { get; }
        int PreviousMouseX { get; }
        int PreviousMouseY { get; }
        int PreviousMouseScrollWheel { get; }
#endif

        bool AClick(PlayerIndex index);
        bool BClick(PlayerIndex index);
        bool XClick(PlayerIndex index);
        bool YClick(PlayerIndex index);
        bool BackClick(PlayerIndex index);
        bool StartClick(PlayerIndex index);
        bool LeftSholderClick(PlayerIndex index);
        bool LeftStickClick(PlayerIndex index);
        bool RightSholderClick(PlayerIndex index);
        bool RightStickClick(PlayerIndex index);
        bool LeftClick(PlayerIndex index);
        bool RightClick(PlayerIndex index);
        bool UpClick(PlayerIndex index);
        bool DownClick(PlayerIndex index);

        void A(PlayerIndex index, ButtonState state);
        void B(PlayerIndex index, ButtonState state);
        void X(PlayerIndex index, ButtonState state);
        void Y(PlayerIndex index, ButtonState state);
        void Back(PlayerIndex index, ButtonState state);
        void Start(PlayerIndex index, ButtonState state);
        void LeftSholder(PlayerIndex index, ButtonState state);
        void LeftStick(PlayerIndex index, ButtonState state);
        void RightSholder(PlayerIndex index, ButtonState state);
        void RightStick(PlayerIndex index, ButtonState state);
        void Left(PlayerIndex index, ButtonState state);
        void Right(PlayerIndex index, ButtonState state);
        void Up(PlayerIndex index, ButtonState state);
        void Down(PlayerIndex index, ButtonState state);
        void LeftThumbStick(PlayerIndex index, Vector2 value);
        void RightThumbStick(PlayerIndex index, Vector2 value);
        void LeftTrigger(PlayerIndex index, float value);
        void RightTrigger(PlayerIndex index, float value);
        void IsConnected(PlayerIndex index, bool value);
        bool KeyClick(Keys key);
#if Win32
        bool LeftMouseButtonClicked { get; }
        bool RightMouseButtonClicked { get; }
        bool MiddleMouseButtonClicked { get; }
        bool XButton1MouseButtonClicked { get; }
        bool XButton2MouseButtonClicked { get; }
        bool MouseXChanged { get; }
        bool MouseYChanged { get; }
        bool MouseScrollWheelChanged { get; }
#endif

        void Update(GameTime gameTime);
    }
}
